#include <stdio.h>
#include <string.h>
#include <string>
#include <vector>
#include <sstream>
#include <algorithm>
#include <iostream>
#include <cmath>
#include <set>
#include <queue>
#include <map>
using namespace std;
int T,N,M,A,W;
vector<string> grid;

unsigned long long startingMoney;
int life;

struct Wave {
    unsigned long long money;
    vector<int> animalsIds;
    vector<int> animalsCount;
};

vector<Wave> waves;

struct Animal {
    int type,speed,life;
};

struct BuildableCell {
    int i;
    int j;
    int coverage;
};

vector<BuildableCell> buildableCells;

bool bcSort(BuildableCell const b1, BuildableCell const b2) {
    return b1.coverage > b2.coverage;
}

struct Turret {
    int id;
    string name;
    int type;
    int speed;
    int range;
    int price;
    int refund;
    double damage[16];
    int needs;
    int neededPrice;
    vector<int> needsId;
    vector<int> origNeeds;
};

bool cmpTurrets(Turret t1, Turret t2) {
    if(t1.type != t2.type || t1.type!=2) {
        if(t1.type == 2)return true;
        if(t2.type == 2)return false;
        return t1.neededPrice+t1.price<t2.neededPrice+t2.price;
    }
    else {
        return t1.neededPrice+t1.price<t2.neededPrice+t2.price;
    }
}

vector<Turret> turrets;
vector<Animal> animals;

set<int> seenTowers;
set<int> inserted;
int topTurretId;

void dfsBestAttackingTurret(int id) {
    if(seenTowers.find(id)!=seenTowers.end())return;
    seenTowers.insert(id);
    bool found = false;
    for(int i=0;i<turrets[topTurretId].needs;i++) {
        if(id==turrets[topTurretId].needsId[i]) {
            found = true;
            break;
        }
    }
    if(!found) {
        turrets[topTurretId].needs++;
        turrets[topTurretId].needsId.push_back(id);
    }
    turrets[topTurretId].neededPrice+=turrets[id].price;
    for(int i=0;i<turrets[id].needs;i++) {
        dfsBestAttackingTurret(turrets[id].needsId[i]);
    }
}



int main()
{
#ifdef __LOCAL__
	freopen("towerdef.in", "r", stdin);
#else
	freopen("towerdef.in", "r", stdin);
 	freopen("towerdef.out", "w", stdout);
#endif
    cin>>N>>M;
    string input;
    for(int i=0;i<N;i++) {
        cin>>input;
        grid.push_back(input);
        //cout<<input;
    }
    cin>>T;
    //cout<<T<<endl;
    for(int t=0;t<T;t++) {
        Turret turret;
        turret.id = t;
        turret.neededPrice = 0;
        cin>>turret.name>>turret.type>>turret.speed>>turret.range>>turret.price>>turret.refund;
        for(int i=0;i<16;i++)cin>>turret.damage[i];
        cin>>turret.needs;
        for(int i=0;i<turret.needs;i++) {
            int needId;
            cin>>needId;
            turret.needsId.push_back(needId);
            turret.origNeeds.push_back(needId);
        }
        turrets.push_back(turret);
    }
    //for(int t=0;t<T;t++)cout<<turrets[t].name<<" "<<turrets[t].needs<<" "<<turrets[t].price<<endl;
    cin>>A;
    for(int a=0;a<A;a++) {
        Animal animal;
        cin>>animal.type>>animal.speed>>animal.life;
        animals.push_back(animal);
    }
    cin>>life>>startingMoney;
    cin>>W;
    for(int w=0;w<W;w++) {
        Wave wave;
        int count;
        cin>>count>>wave.money;
        for(int c=0;c<count;c++) {
            int anCount,anId;
            cin>>anId>>anCount;
            wave.animalsIds.push_back(anId);
            wave.animalsCount.push_back(anCount);
        }
        waves.push_back(wave);
    }

    for(int i=0;i<N;i++)
        for(int j=0;j<M;j++) {
            if(grid[i][j]=='.') {
                BuildableCell bc;
                bc.i = i;
                bc.j = j;
                bc.coverage = 0;
                buildableCells.push_back(bc);
            }
        }

    //cout<<"bc size"<<buildableCells.size()<<endl;

    for(int t=0;t<T;t++) {
        seenTowers.clear();
        topTurretId = t;
        for(int nt = 0;nt<turrets[t].needs;nt++) {
            dfsBestAttackingTurret(turrets[t].needsId[nt]);
        }
    }

    int weNeed = -1;

    vector<Turret> toBuy;
    for(int i=0;i<(int)turrets.size();i++)toBuy.push_back(turrets[i]);
    sort(toBuy.begin(),toBuy.end(),cmpTurrets);


    for(int i=0;i<(int)toBuy.size();i++) {
        if(toBuy[i].needs+1>(int)buildableCells.size() || toBuy[i].type!=2)continue;
        else {
            weNeed = i;
            break;
        }
    }

    if(weNeed == -1) {
        for(int w=0;w<(int)waves.size();w++)cout<<0<<endl;
    }
    else {
        Turret* best = &toBuy[weNeed];
        for(int b=0;b<(int)buildableCells.size();b++)
            for(int i=max(0,buildableCells[b].i-best->range);i<=min(N-1,buildableCells[b].i+best->range);i++)
                for(int j=max(0,buildableCells[b].j-best->range);j<=min(M-1,buildableCells[b].j+best->range);j++)
                    if(grid[i][j]=='#' || grid[i][j]=='S')buildableCells[b].coverage++;

        sort(buildableCells.begin(),buildableCells.end(),bcSort);
        //cout<<"bestid"<<weNeed<<best->id;

        int bestBought = 0;

        set<int> depBought;

        char buyBuffer[100000];
        int lastBufferId = 0;

        map<int,pair<int,int> > whereBuilt;

        for(int w=0;w<W;w++) {
            buyBuffer[0]='\0';
            lastBufferId = 0;
            int commands = 0;

            while(depBought.size()<best->needs) {
                bool boughtOne = false;
                for(int i=0;i<best->needs;i++) {
                    Turret* consider = &turrets[best->needsId[i]];
                    if(depBought.find(consider->id)!=depBought.end())continue;
                    bool hasDependency=false;
                    for(int d=0;d<consider->needs;d++) {
                        if(depBought.find(consider->needsId[d])==depBought.end()) {
                            hasDependency = true;
                            break;
                        }
                    }
                    if(hasDependency == false && startingMoney >= consider->price) {
                        startingMoney-=consider->price;
                        int bbcId = (int)buildableCells.size()-1-(int)depBought.size();
                        if(bbcId<0)break;
                        boughtOne = true;
                        lastBufferId += sprintf(buyBuffer+lastBufferId,"4 %d %d %d",buildableCells[bbcId].i,buildableCells[bbcId].j,consider->id);
                        for(int oi=0;oi<consider->origNeeds.size();oi++) {
                            lastBufferId += sprintf(buyBuffer+lastBufferId," %d %d",whereBuilt[consider->origNeeds[oi]].first,whereBuilt[consider->origNeeds[oi]].second);
                        }
                        lastBufferId += sprintf(buyBuffer+lastBufferId,"\n");
                        depBought.insert(consider->id);
                        whereBuilt[consider->id] = make_pair(buildableCells[bbcId].i,buildableCells[bbcId].j);
                        commands++;
                    }
                }
                if(!boughtOne)break;
            }

            //cout<<depBought.size()<<" is equal"<<(best->needs)<<endl;

            if(depBought.size()==best->needs) {
                //cout<<"yes"<<endl;
                for(;bestBought<(int)buildableCells.size()-depBought.size();bestBought++) {
                    //cout<<bestBought<<" bb "<<startingMoney<<endl;
                    if(startingMoney>=best->price) {
                        startingMoney-=best->price;
                        int bbcId = bestBought;
                        //cout<<"lb"<<lastBufferId<<endl;
                        lastBufferId += sprintf(buyBuffer+lastBufferId,"4 %d %d %d",buildableCells[bbcId].i,buildableCells[bbcId].j,best->id);

                        for(int oi=0;oi<(int)best->origNeeds.size();oi++) {
                            lastBufferId += sprintf(buyBuffer+lastBufferId," %d %d",whereBuilt[best->origNeeds[oi]].first,whereBuilt[best->origNeeds[oi]].second);
                        }
                        lastBufferId += sprintf(buyBuffer+lastBufferId,"\n");
                        //cout<<"we bought stuff"<<endl;
                        commands++;
                    }
                    else break;
                }
            }

            cout<<commands<<endl;
            if(commands>0) {
                cout<<buyBuffer;
            }

            startingMoney+=waves[w].money;
        }
    }

    return 0;
}
